<template>
  <header v-if="isHeaderShow" ref="headerRef" class="app__main-header">
    <HeaderMBk8green
      v-if="isBk8Green"
      :theme-properties="themeProperties"
      :auth="auth"
      :actived-tab="activedTab"
    />
    <template v-else>
      <div
        class="flex items-center px-4 border-b4 bg-background3 mobile-header h-[52px]"
        :class="[isPlayful && 'py-4', isMain ? 'py-[10.5px]' : 'py-2.5']"
      >
        <div
          v-if="!logo.IsHidden"
          class="w-full logo"
          :class="[isPlayful && 'w-full']"
        >
          <nuxt-link :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'">
            <figure
              class="object-contain"
              :class="[
                !isPlayful && !isMain ? 'w-[150px] h-[42px]' : '',
                isPlayful && 'h-[32px]',
                isMain ? 'h-[30px]' : '',
              ]"
            >
              <img
                :src="logo.ImagePath"
                alt="Dark Theme"
                class="object-contain object-center"
                :class="[
                  isPlayful && '!h-[32px]',
                  isMain ? 'h-[30px] w-[90px]' : 'w-[150px] h-[42px]',
                ]"
              />
            </figure>
          </nuxt-link>
        </div>
        <div
          v-if="isPlayful && !auth && !isIndependentModule"
          class="h-full inline-block"
        >
          <div class="flex">
            <div class="logout-action !p-0">
              <button class="w-[74px] mx-2" @click="onClickLogin">
                <span class="label">{{ $t("capital_login") }}</span>
              </button>
            </div>
            <div v-if="!register.IsHidden" class="joinnow-action !p-0">
              <button :id="ID.SIGNUP" class="w-[74px]" @click="onClickJoinnow">
                <span class="label pointer-events-none">{{
                  $t("joinnow")
                }}</span>
              </button>
            </div>
          </div>
        </div>
        <div
          v-else-if="isd9betUnauth"
          class="flex items-center w-1/2 gap-3 mr-2"
        >
          <button class="btn bg-secondary" @click="toggleAuthModal('login')">
            <span class="text-base font-bold leading-4">{{
              $t("capital_login")
            }}</span>
          </button>
          <button class="btn bg-primary" @click="toggleAuthModal('register')">
            <span class="text-base font-bold leading-4">{{
              $t("joinnow")
            }}</span>
          </button>
        </div>
        <div
          v-else
          class="flex justify-end items-center"
          :class="[isMain ? 'items-center' : '']"
        >
          <theme-mobile-main-components-balance-info
            v-if="auth && theme === 'bk8'"
            :is-suspended="false"
          />
          <div
            v-if="auth && theme !== 'bk8'"
            :class="isBk8Green ? 'bk8-balance' : ''"
          >
            <utils-balance-information :is-suspended="false" class="mr-2" />
          </div>
          <template v-if="theme.includes('global') || isPlayful">
            <theme-desktop-global-components-menu-drawer />
          </template>
          <new-black-theme-hamburger-menu
            v-if="!(theme.includes('global') || isPlayful)"
          />
        </div>
      </div>
      <template v-if="!hideAnnouncement">
        <div
          v-if="!announcement.IsHidden && activedTab && theme === 'bk8'"
          class="py-2 bg-background1 h-[32px] overflow-hidden pl-2"
        >
          <div class="container flex items-center h-full mx-auto z-10">
            <utils-announcement :announcement="announcement.Text" />
          </div>
        </div>
        <div
          v-if="
            includeAnnouncement && !announcement.IsHidden && theme !== 'bk8'
          "
          class="py-2 bg-background1 h-[32px] overflow-hidden"
        >
          <div class="container flex items-center h-full mx-auto">
            <utils-announcement :announcement="announcement.Text" />
          </div>
        </div>
      </template>
    </template>
  </header>
</template>

<script lang="ts">
import { useElementSize } from "@vueuse/core";
import { computed, defineComponent, PropType, toRefs } from "vue";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";
import { useHeaderComponent } from "@/composables/useTheme";

const shownRoute = [
  "home",
  "sports",
  "virtual-sports",
  "live-casino",
  "games",
  "game-entry",
  "keno",
  "poker",
  "cockfight",
  "lottery",
  "promotion",
  "contact-us",
  "index",
];

export default defineComponent({
  props: {
    auth: {
      type: Boolean,
      default: false,
    },
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    includeAnnouncement: {
      type: Boolean,
      required: false,
      default: false,
    },
    activedTab: {
      type: Boolean,
      default: false,
    },
    hideAnnouncement: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          props.themeProperties,
          "logo"
        )
    );
    const router = useRouter();
    const route = useRoute();
    const isMobile = !useIsDesktop();
    const { name } = toRefs(route);
    const isHeaderShow = computed(() =>
      shownRoute.some(
        (item) =>
          String(name.value).includes(item) &&
          !String(name.value).includes("my-promotion") &&
          !commonHelper.isIndependentGameFilterPage()
      )
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          store.state.companyThemePropertiesFromApi.ThemeProperties,
          "announcement"
        )
    );
    const { getAssetImage } = commonHelper;
    const { toggleLoginRegisterDialog } = commonHelper;
    const isd9betUnauth = computed(
      () => store.state.selectedThemeName.includes("black") && !store.state.auth
    );
    const toggleAuthModal = (option: "login" | "register"): void => {
      if (option === "login") {
        store.commit("updateLoginDialog", !store.state.showLoginDialog);
      }
      if (option === "register") {
        store.commit("updateRegisterDialog", !store.state.showRegisterDialog);
      }
    };
    const onClickLogin = () => {
      if (isMobile) toggleLoginRegisterDialog();
      else router.push("/login");
    };

    const onClickJoinnow = () => {
      if (isMobile) toggleLoginRegisterDialog(false);
      else router.push("/register");
    };
    const { themeColor } = themePropertyHelper;
    const theme = themeColor.value.Text;
    const isIndependentModule = useState(KEYS.IS_INDEPENDENT_MODULE);
    const isPlayful = computed(
      () =>
        store.state.selectedThemeName === "playful" || isIndependentModule.value
    );
    const isMain = computed(() =>
      store.state.companyThemePropertiesFromApi.ThemeProperties[0].ThemeName.toLowerCase().includes(
        "main"
      )
    );
    const isGlobal = computed(() => store.state.selectedThemeName === "global");
    const isBk8Green = computed(() => theme === "bk8_green");
    const { register } = useHeaderComponent();

    const headerRef = ref();
    const { height } = useElementSize(headerRef);

    const setProperty = (key: string, value: string | number) => {
      document.documentElement.style.setProperty(key, `${value}`);
    };

    watch(
      height,
      () => {
        setProperty("--mobile-header-height", `${height.value}px`);
      },
      {
        immediate: true,
        deep: true,
      }
    );

    return {
      logo,
      isHeaderShow,
      getAssetImage,
      toggleAuthModal,
      isd9betUnauth,
      announcement,
      theme,
      isPlayful,
      onClickLogin,
      onClickJoinnow,
      isMain,
      isGlobal,
      register,
      isBk8Green,
      headerRef,
      isIndependentModule,
    };
  },
});
</script>
<style scoped>
.btn {
  @apply inline-block text-center rounded-2xl transition-colors duration-300;
  padding: 0.18rem 0 !important;
  width: 90px;
  min-width: 90px;
}
:deep(.menu-btn) {
  align-items: center;
}
</style>
<style lang="scss">
[theme-color="bk8"] .bk-8-balance-info {
  margin-right: 0;
  > ul {
    padding-right: 16px;
  }
}
[layout="global"] .mobile-header {
  padding-right: 12px;
}
[layout="playful"] {
  .mobile-header {
    padding-left: 8px;
    padding-right: 8px;

    .logout-action,
    .joinnow-action {
      button {
        height: 32px;
        width: auto;
        span {
          white-space: nowrap;
          color: var(--textBtn);
        }
      }
    }
    .logo {
      img {
        -o-object-position: left;
        object-position: left;
      }
    }
  }
  .balance-spacer {
    width: 0;
  }
}
.logout-action button {
  display: flex;
  padding: 8px;
  justify-content: center;
  align-items: center;
  gap: 4px;
  align-self: stretch;
  border-radius: 4px;
  background: var(--secondary, #6b52cb);
}
.logout-action button .label {
  color: var(--text4_w);
  text-align: center;
  font-size: 12px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
}
.joinnow-action {
  display: flex;
  padding: 16px;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  gap: 8px;
  align-self: stretch;
}
.logout-action button .label {
  color: var(--text4_w);
  text-align: center;
  font-size: 12px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
}
.joinnow-action {
  display: flex;
  padding: 16px;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  gap: 8px;
  align-self: stretch;
}
.joinnow-action button {
  display: flex;
  padding: 8px;
  justify-content: center;
  align-items: center;
  gap: 4px;
  align-self: stretch;
  border-radius: 4px;
  background: var(--primary, #31c46e);
}
.joinnow-action button .label {
  color: var(--text4_w);
  text-align: center;
  font-size: 12px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
}
</style>
